﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI.Widgets;
using Telerik.Web.UI;
using System.IO;

namespace Telerik.Web.Examples.FileExplorer.CustomGridColumns
{
	public partial class Default : System.Web.UI.Page
	{
		protected void Page_Load(object sender, EventArgs e)
		{
			if (!IsPostBack)
			{
				RadFileExplorer1.Configuration.ContentProviderTypeName = typeof(CustomColumnsContentProvider).AssemblyQualifiedName;

				string[] paths = new string[] { "~/Products" };
				RadFileExplorer1.Configuration.ViewPaths = paths;
				RadFileExplorer1.Configuration.UploadPaths = paths;
				RadFileExplorer1.Configuration.DeletePaths = paths;
			}
			AddThumbnailColumn();
		}

		private void AddGridColumn(string name, string uniqueName, bool sortable)
		{
			RemoveGridColumn(uniqueName);
			GridTemplateColumn gridTemplateColumn1 = new GridTemplateColumn();
			gridTemplateColumn1.HeaderText = name;
			if (sortable)
			{
				gridTemplateColumn1.SortExpression = uniqueName;
			}
			gridTemplateColumn1.UniqueName = uniqueName;
			gridTemplateColumn1.DataField = uniqueName;
			RadFileExplorer1.Grid.Columns.Add(gridTemplateColumn1);
		}
		private void RemoveGridColumn(string uniqueName)
		{
			if (!Object.Equals(RadFileExplorer1.Grid.Columns.FindByUniqueNameSafe(uniqueName), null))
			{
				RadFileExplorer1.Grid.Columns.Remove(RadFileExplorer1.Grid.Columns.FindByUniqueNameSafe(uniqueName));
			}
		}

		private void AddThumbnailColumn()
		{
			AddGridColumn("Thumb", "Thumb", false);
		}

		public class CustomColumnsContentProvider : Telerik.Web.UI.Widgets.FileSystemContentProvider
		{
			public CustomColumnsContentProvider(HttpContext context, string[] searchPatterns, string[] viewPaths, string[] uploadPaths, string[] deletePaths, string selectedUrl, string selectedItemTag)
				: base(context, searchPatterns, viewPaths, uploadPaths, deletePaths, selectedUrl, selectedItemTag)
			{
			}

			public override DirectoryItem ResolveDirectory(string path)
			{
				DirectoryItem oldItem = base.ResolveDirectory(path);
				foreach (FileItem fileItem in oldItem.Files)
				{
					string[] imageExtensios = new string[] { ".jpg", ".gif", ".png" };// Images extensios

					if (imageExtensios.Contains(fileItem.Extension))
					{//Show thumbnails for images only
						string pathToFile = fileItem.Location;
						string htmlText = "<img src='" + pathToFile + "' alt='" + fileItem.Name + "' class='thumbImages'/>";
						fileItem.Attributes.Add("Thumb", htmlText);
					}
				}
				return oldItem;
			}
		}
	}
}

